//+------------------------------------------------------------------+
//|                                                      FazaMA0.mq4 |
//|                             Copyright  2011, Avatara@bigmir.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010-2011, Avatara@bigmir.net"
#property link      "Avatara@bigmir.net"        //         29/03/2011
#property show_confirm
#property show_inputs
extern int M=10000;
extern bool Prints=false;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {  
    int hFile,Tf1,N1;
    int i=0,j=0,Records=M,KK[8,24];
    string Name_Files,NameVal;
    double Mass[8][24][2];
    ArrayInitialize(Mass,0);
    ArrayInitialize(KK,0);
    Tf1=Period();
    NameVal=Symbol();
    Name_Files=StringConcatenate("F_",NameVal,Tf1,"_",
               TimeYear(Time[0]),"_",TimeMonth(Time[0]),"_",
               TimeDay(Time[0]),"X",TimeHour(Time[0]),"_",
               TimeMinute(Time[0]),".csv");
    Print ("Save FazaMA0! ",Name_Files);
    hFile=FileOpen(Name_Files,FILE_CSV |FILE_WRITE,";");
    if (hFile<1) {
             Alert ("Not Open Faza file...");
             return ;
             }
    //++++++
    N1=Bars-1;
    Print ("Tf1=",Tf1,"N1=",N1);
    if (M>N1) Records=N1;
      
//-------------------------------------------------------------------*/         
  
    FileWrite(hFile,"DayW","Hour",
       "TPS" ,"std",NameVal+Period(),
        dataConvF(iTime(NameVal,Tf1,Records)),
        dataConvF(iTime(NameVal,Tf1,0)));              
   for (i=0;i<Records;i++)
    { datetime T=iTime(NameVal,Tf1,i);
     int k=TimeDayOfWeek(T);
      j=TimeHour(T);
      KK[k,j]++;
      KK[7,j]++;
      Mass[k][j][0]+=iVolume(NameVal,Tf1,i)/(Period()*60.0);
      Mass[7][j][0]+=iVolume(NameVal,Tf1,i)/(Period()*60.0);
     if (Prints) FileWrite(hFile,k,j,iVolume(NameVal,Tf1,i),
                Mass[k][j][0], KK[k,j],Mass[7][j][0]);
    }
    for (i=0;i<8;i++){
     for (j=0;j<24;j++){
      if (KK[i,j]>0)  Mass[i][j][0]=Mass[i][j][0]/KK[i,j]; 
     }                       
    }  
   for (i=Records;i>=0;i--)
    {  T=iTime(NameVal,Tf1,i);
       k=TimeDayOfWeek(T);
       j=TimeHour(T);
    if ((KK[k,j]-1)>0) 
      Mass[k][j][1]+=(Mass[k][j][0]-iVolume(NameVal,Tf1,i)/(Period()
                     *60.))*(Mass[k][j][0]-iVolume(NameVal,
                     Tf1,i)/(Period()*60.0));
    if (KK[7,j]-1>0)  
      Mass[7][j][1]+=(Mass[7][j][0]-iVolume(NameVal,Tf1,i)/(Period()
                     *60.0))*(Mass[7][j][0]-iVolume(NameVal,
                     Tf1,i)/(Period()*60.0));               
    }          
    for (i=0;i<8;i++){
     for (j=0;j<24;j++){
      if ((KK[i,j]-1)>0) 
      Mass[i][j][1]=MathSqrt(Mass[i][j][1]/(KK[i,j]-1.0));
      FileWrite(hFile,i,j,
              Mass[i][j][0],
              Mass[i][j][1],KK[i,j] 
              );
     }                       
    } 
   FileClose(hFile);Print ("Finish! ", Records);
} 
//+------------------------------------------------------------------+
string dataConvF(datetime T){
  return(StringConcatenate(TimeYear(T),"/",TimeMonth(T),
  "/",TimeDay(T)," ",TimeHour(T),":",TimeMinute(T)));}
//+------------------------------------------------------------------+